unit uFooBar;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, SynEdit;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnBar: TButton;
    btnFoo: TButton;
    Label1: TLabel;
    Label2: TLabel;
    me: TSynEdit;
    procedure btnFooClick(Sender: TObject);
    procedure btnBarClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

uses lgHashMap, lgUtils;
  {$R *.lfm}

  { TForm1 }

  {$DEFINE LITE_VERSION}      // undefine this, both TFoo and TBar are working properly.
                              // define LITE_VERSION, TFoo working properly, TBar go wrong.
type
  {$IFDEF LITE_VERSION}
  TTestMapSpec = specialize TGLiteHashMapLP<string, string, string>;
  TTestMap = TTestMapSpec.TMap;
  {$ELSE}
  TTestMap = specialize TGHashMapLP<string, string>;
  {$ENDIF}
  { TFoo }

  TFoo = class
  private
    FMap: TTestMap;

    procedure DoInitialize;
    procedure DoFinalize;
  public
    constructor Create;
    destructor Destroy; override;

    procedure print(sList: TStringList);
    procedure Add(k, v: string);
  end;

  { TBar }

  TBar = class(TFoo)
  private

  public
    constructor Create;
    destructor Destroy; override;

    procedure AddMore;
  end;

procedure TForm1.btnBarClick(Sender: TObject);
var
  b: TBar;
  sList: TStringList;
begin
  b := TBar.Create;
  sList := TStringList.Create;
  try
    b.print(sList);
    sList.Sort;
    me.Lines := sList;
    me.Append('******************');

    b.AddMore;
    b.print(sList);
    sList.Sort;
    me.Lines.AddStrings(sList);
  finally
    b.Free;
    sList.Free;
  end;
end;

procedure TForm1.btnFooClick(Sender: TObject);
var
  f: TFoo;
  sList: TStringList;
  i: integer;
begin
  f := TFoo.Create;
  sList := TStringList.Create;
  try
    f.print(sList);
    sList.Sort;
    me.Lines := sList;
    me.Append('===================');

    for i := 1 to 10 do
      f.Add(Format('Foo_Add__%.3d', [i]), Format('Val__%.3d', [100 + i]));
    f.print(sList);
    sList.Sort;
    me.Lines.AddStrings(sList);
  finally
    f.Free;
    sList.Free;
  end;
end;

{ TFoo }

procedure TFoo.DoInitialize;
var
  i: integer;
begin
  {$IFNDEF LITE_VERSION}
  FMap := TTestMap.Create;
  {$ENDIF}
  for i := 1 to 20 do
    FMap.Add(Format('Foo_Init_%.3d', [i]), Format('Val_%.3d', [i]));
end;

procedure TFoo.DoFinalize;
begin
  FMap.Clear;
end;

constructor TFoo.Create;
begin   // at here, the compiler will call TGLiteHashTableLP.Initialize(var ht: TGLiteHashTableLP) when directly call TFoo.Create but TBar.Create -> TFoo.Create, will NOT.
  inherited;
  DoInitialize;
end;

destructor TFoo.Destroy;
begin
  DoFinalize;
  inherited Destroy;
end;

procedure TFoo.print(sList: TStringList);
{$IFDEF LITE_VERSION}
var
  e: TTestMap.TEntryEnumerator;
begin
  e := FMap.GetEnumerator;
  while e.MoveNext do
    sList.Add(e.Current.Key + '---' + e.Current.Value);
end;

{$ELSE}
type
 TMyMapEntry = specialize TGMapEntry<string, string>;
var
  e: TTestMap.IEntryEnumerable;
  eArr: array of TMyMapEntry;
  k, v: string;
  i: integer;
begin
  sList.Clear;
  e := FMap.Entries;
  eArr := e.ToArray;
  for i:=Low(eArr) to High(eArr) do
  begin
    k := eArr[i].Key;
    v := eArr[i].Value;
    sList.Add(k + '---' + v);
  end;
end;
{$ENDIF}

procedure TFoo.Add(k, v: string);
begin
  FMap.Add(k, v);
end;

{ TBar }

constructor TBar.Create;
begin
  inherited;
end;

destructor TBar.Destroy;
begin
  inherited;
  inherited Destroy;
end;

procedure TBar.AddMore;
var
  i: integer;
begin
  for i := 1 to 10 do
    Add(Format('Bar_more__%.3d', [i]), Format('Val__%.3d', [100 + i]));
end;

end.
